/**************************************************************************
 * @file        DRV8343.h
 * @author      MDBU Software Team
 * @date        13th Novemeber 2017
 * @brief       This file defines all the functions and data structures used for accessing DRV8343 registers
 * @note        Copyright (c) 2017 Texas Instruments Incorporated.
 *              All rights reserved.
 ******************************************************************************/

#ifndef DRV8x_HAL_H_
#define DRV8x_HAL_H_

#include "dataTypeDefinition.h"

void drv83xx_Control_Init(void);
void drv83xx_Register_Read(void);
void drv83xx_Register_Init(void);
void drv83xx_Register_Write(void);
void drv83xx_regRestoreFromCache(void);
unsigned int drv83xx_cachetoReg(unsigned char address);
void drv83xx_regToCache(unsigned char address, unsigned int regValue);
void drv83xx_ClearFault_Status(void);
void drv83xx_Start_OLP_Test(void);
unsigned int drv83xx_getFault_Status(void);
void drv83xx_set_Six_PWM_Mode(void);
void drv83xx_set_One_PWM_Mode(void);
void drv83xx_set_IND_ABC_PWM_Mode(void);
void drv83xx_set_IND_AB_FET_C_PWM_Mode(void);
void drv83xx_set_IND_BC_FET_A_PWM_Mode(void);
void drv83xx_set_IND_A_FET_BC_PWM_Mode(void);
void drv83xx_set_FET_ABC_PWM_Mode(void);
inline unsigned char drv83xx_is_CSA_BI_DIR_Mode(void);

unsigned short drv8343_SPI_Read(uint8_t regAddr);
void drv8343_SPI_Write(uint8_t regAddr, uint8_t data);
/********** Fault Status Indication *******/
#define OVER_CURRENT_FAULT				1
#define GATE_DRIVE_FAULT				2
#define CHARGE_PUMP_UV_FAULT			3
#define UNDER_VOLTAGE_LOCK_OUT_FAULT	4
#define OVER_TEMPERATURE_FAULT			5
#define OPEN_LOAD_SHORT_FAULT			6
#define UNKNOWN_FAULT					7
#define NO_FAULT						8

#define DRV8343_DEVICE				    4           // Device variant used for DRV8343x
#define FULL_SCALE_VOLTAGE             (67)			/*As BEMF for above full scale volts may give ADC ref volts exceeds nominal value 3.3V , MAX VCC is limited*/

/////////////////////////
#endif /*DRV8x_HAL_H_*/
